# This file was created automatically by SWIG.
import timestepadaptermanagerc
from oof2.SWIG.engine.femesh import FEMeshPtr
from oof2.SWIG.engine.csubproblem import CSubProblemPtr
from oof2.SWIG.engine.steppingscheme import SteppingSchemePtr
class TimeStepAdapterManagerPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C TimeStepAdapterManager instance at %s>" % (self.this,)
class TimeStepAdapterManager(TimeStepAdapterManagerPtr):
    def __init__(self,this):
        self.this = this






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: timestepadaptermanager.spy,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2005-10-18 17:31:27 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from oof2.common import cregisteredclass
import oof2.engine.mesh

cregisteredclass.registerCClass(TimeStepAdapterManagerPtr)

## the base class does NOT know how to iterate
def __iterate(self, mesh, sproblemlist):
    pass
TimeStepAdapterManagerPtr.iterate = __iterate

## base class does NOT know how to set time step
def __set_time_step(self, meshcontext, sproblemlist):
    pass
TimeStepAdapterManagerPtr.set_time_step = __set_time_step

## base class does NOT know how to apply itself
def __apply(self, initialize_function, finalize_function, mesh, sproblemlist):
    pass
TimeStepAdapterManagerPtr.apply = __apply


def __update(self, initialize_function, finalize_function, mesh, sproblemlist):
    ## base class does not do anything.
    ## subclass determines if *global* solution
    ## should be accepted based on some
    ## function of the residuals of each time
    ## step adapter
    pass 
TimeStepAdapterManagerPtr.update = __update

## In case you are wondering:
## The base class only knows how to accept AND
## reject solutions from a timedriver object.
## The way in which a specific criteria is
## defined is determined by the subclass.

class NullTAManager (TimeStepAdapterManager):
    def __init__(self):
        pass
    def evaluate_criteria(self, tdriver):
        return tdriver.timeadaptermethod.is_okay(tdriver.steppermethod)
    def update(self, initialize_function, finalize_function, mesh, sproblemlist):
        acceptance_state = 1
        ## first check if the solutions for all the
        ## subregions are within bounds
        ## this is a quick loop
        for sproblem in sproblemlist:
            if self.evaluate_criteria(sproblem.timedriver) == 0:
                acceptance_state = 0
                break
        ## next, if all solutions are okay, accept global
        ## solution. Otherwise reject all and apply
        ## whatever method each individual time driver has
        ## to improve the time step.
        meshcontext = oof2.engine.mesh.meshes[mesh]
        femesh =  meshcontext.femesh()
        if acceptance_state>0:
            for sproblem in sproblemlist:
                self.accept(femesh, sproblem, sproblem.timedriver.steppermethod)
        else:
            for sproblem in sproblemlist:
                self.reject(femesh, sproblem)

    def set_time_step(self, meshcontext, sproblemlist):
        dt_list = []
        for sproblem in sproblemlist:
            dt_candidate = sproblem.timedriver.timestepadaptermethod.get_dt()
            if dt_candidate>0:
                dt_list.append(dt_candidate)
        dt = min(dt_list) 
        meshcontext.getObject().update_time(dt)
    ##
    def iterate(self, mesh, sproblemlist):
        meshcontext = oof2.engine.mesh.meshes[mesh]
        ## every subproblem iterates ONCE, from t_n to t_{n+1}
        ## but solution is only accepted IF all step adapters
        ## agree AND the global controls also says so.
        global_state = 1
        for sproblem in sproblemlist:
            global_state *= sproblem.get_step_adapter_state()
        if global_state>0:
            self.set_time_step(meshcontext.getObject(), sproblemlist)
    def apply(self, initialize_function, finalize_function, mesh, sproblemlist): ## mesh is a mesh name
        for sproblem in sproblemlist:
            initialize_function() ## provided by the problem manager
            sproblem.precompute(mesh) ## set active fields and equations
            sproblem.apply(mesh) ## apply stepper and mesh driver. 
            sproblem.postcompute(mesh)  ## cleanup without accepting solution: t+dt is forbidden here!!!
            ## Should also save mapping(s)
            finalize_function(sproblem) ## reset settings in mesh; provided by problem manager
