# -*- python -*-
# $RCSfile: menulogger.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2007-06-05 18:57:31 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import gtk
import loggers
import logutils

import string

class MenuLogger(loggers.GtkLogger):
    classes = (gtk.MenuItem,)
    def location(self, menuitem, *args):
        parent, path = self._getMenuPath(menuitem)
        parentcode = loggers.findLogger(parent).location(parent)
        return "findMenu(%s, '%s')" % (parentcode, string.join(path, ':'))
    def record(self, object, signal, *args):
        if signal == "activate":
            return ["%s.activate()" % self.location(object, args)]
        return super(MenuLogger, self).record(object, signal, *args)
    
    # Find a list of menu item names leading to the given
    # gtk.MenuItem.  This relies on setting gtk.Menu.oofparent in
    # gtklogger.set_submenu.  The return value is a tuple containing
    # the parent widget of the top of the menu hierarchy and the list
    # of menuitem names.
    def _getMenuPath(self, gtkmenuitem):
        path = [logutils.getWidgetName(gtkmenuitem)]
        parent = gtkmenuitem.get_parent()
        if isinstance(parent, gtk.Menu) and \
               isinstance(parent.oofparent, gtk.MenuItem):
            pparent, ppath = self._getMenuPath(parent.oofparent)
            return pparent, ppath+path
        else:
            return parent, path

