# -*- python -*- 
# $RCSfile: DIR.py,v $
# $Revision: 1.9 $
# $Author: langer $
# $Date: 2007-06-18 19:33:46 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modifed
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

dirname = 'image'
clib = 'oof2image'
clib_order = 2
subdirs = ['IO']
if ENABLE_SEGMENTATION:
    subdirs.append('SEGMENTATION')

cfiles = [
    'oofimage.C', 'burn.C', 'evenlyilluminate.C',
    'pixelselectioncourieri.C']

swigfiles = ['oofimage.swg', 'burn.swg', 'pixelselectioncourieri.swg']

swigpyfiles = ['oofimage.spy', 'burn.spy']

pyfiles = [
    'initialize.py', 'pixelselectionmethod.py', 'pixelselectionmod.py',
    'imagemodifier.py']

hfiles = ['oofimage.h', 'burn.h', 'pixelselectioncourieri.h']

def set_clib_flags(c_lib):
    import oof2setuputils
    c_lib.externalLibs.append('oof2common')
    if oof2setuputils.check_exec('Magick++-config'):
        oof2setuputils.add_third_party_includes('Magick++-config --cppflags',
                                                c_lib)
        oof2setuputils.add_third_party_libs('Magick++-config --ldflags --libs',
                                            c_lib)
    else:
        print "Can't find Magick++-config!  Your ImageMagick installation may be defective."

