# -*- python -*-
# $RCSfile: orientmapwhowidget.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2007-05-17 19:10:14 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


# Widgets for listing Microstructures with or without Orientation Map data.

from oof2.SWIG.orientationmap import orientmapdata
from oof2.common import debug
from oof2.common.IO import whoville
from oof2.common.IO.GUI import whowidget
from oof2.orientationmap import orientmapmenu

def _withOrientationMap(who):
    return (whoville.excludeProxies(who) and
            orientmapdata.getOrientationMap(who.getObject()) is not None)

class MicrostructureWithOrientationMapWidget(whowidget.WhoParameterWidget):
    def __init__(self, value=None, scope=None, name=None):
        whowidget.WhoParameterWidget.__init__(
            self, whoclass=whoville.getClass('Microstructure'),
            value=value, scope=scope, name=name,
            condition=_withOrientationMap)

def _MicrostructureWithOrientMapParameter_makeWidget(self, scope=None):
    return MicrostructureWithOrientationMapWidget(self.value, scope=scope,
                                       name=self.name)

orientmapmenu.MicrostructureWithOrientMapParameter.makeWidget = \
                                 _MicrostructureWithOrientMapParameter_makeWidget

##########

def _withoutOrientationMap(who):
    result = (whoville.excludeProxies(who) and
            orientmapdata.getOrientationMap(who.getObject()) is None)
    return result

class MicrostructureWithoutOrientationMapWidget(whowidget.WhoParameterWidget):
    def __init__(self, value=None, scope=None, name=None):
        whowidget.WhoParameterWidget.__init__(
            self, whoclass=whoville.getClass('Microstructure'),
            value=value, scope=scope, name=name,
            condition=_withoutOrientationMap)

def _MicrostructureWithoutOrientMapParameter_makeWidget(self, scope=None):
    return MicrostructureWithoutOrientationMapWidget(self.value, scope=scope,
                                       name=self.name)

orientmapmenu.MicrostructureWithoutOrientMapParameter.makeWidget = \
                            _MicrostructureWithoutOrientMapParameter_makeWidget
